﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals
	
End Sub

Public Sub Initialize

End Sub

Public Sub SortList(Data As List)
	QuickSort(0, Data.Size - 1, Data)
End Sub

Private Sub QuickSort (left As Int, right As Int, Data As List)
	If right > left Then
		Dim pivotIndex, pivotNewIndex As Int
		pivotIndex = Rnd(left, right + 1) 'max value is exclusive
		pivotNewIndex = Partition(left, right, pivotIndex, Data)
		QuickSort(left, pivotNewIndex - 1, Data)
		QuickSort(pivotNewIndex + 1, right, Data)
	End If
End Sub

Private Sub Swap(index1 As Int, index2 As Int, Data As List)
	Dim temp As Object = Data.Get(index1)
	Data.Set(index1, Data.Get(index2))
	Data.Set(index2, temp)
End Sub


Private Sub Partition (left As Int, right As Int, pivotIndex As Int, Data As List) As Int
	Dim storeIndex As Int = left
	Dim pivotValue As Object = Data.Get(pivotIndex)
	Swap(pivotIndex, right, Data)
	For i = left To right - 1
		'the magic happens here
		If CallSub2(Data.Get(i), "CompareTo", pivotValue) <= 0 Then
			Swap(i, storeIndex, Data)
			storeIndex = storeIndex + 1
		End If
	Next
	Swap(storeIndex, right, Data)
	Return storeIndex
End Sub
